<template>
  <div class="column is-3">
    <div class="card">
      <header class="card-header">
        <p v-if="!editMode" class="card-header-title">
          {{ form.name }}
        </p>
        <b-field v-if="editMode">
          <b-input v-model="update.name" :placeholder="form.name" />
        </b-field>
      </header>
      <div class="card-content">
        <div v-if="!editMode" class="content">
          {{ form.description }}
        </div>
        <b-field v-if="editMode">
          <b-input v-model="update.description" :placeholder="form.description" maxlength="500" type="textarea" />
        </b-field>
      </div>
      <footer class="card-footer" v-if="!editMode">
        <router-link :to="`/form/${form.id}`" class="card-footer-item has-text-primary">View</router-link>
        <a @click="editMode = !editMode" class="card-footer-item has-text-info">Edit</a>
        <a @click="confirmDeleteForm(form)" class="card-footer-item has-text-danger">Delete</a>
      </footer>
      <footer class="card-footer" v-if="editMode">
        <a @click="editMode = !editMode" class="card-footer-item has-text-danger">Cancel</a>
        <button @click="confirmUpdateForm(form)" class="card-footer-item" :class="{'has-text-success': newData}" :disabled="!newData">Save</button>
      </footer>
    </div>
  </div>
</template>

<script>
import ALL_FORMS_QUERY from '@/graphql/Form/AllForms.gql'
import UPDATE_FORM_MUTATION from '@/graphql/Form/UpdateForm.gql'
import DELETE_FORM_MUTATION from '@/graphql/Form/DeleteForm.gql'
export default {
  props: { form: Object },
  data: () => ({
    editMode: false,
    update: {}
  }),
  computed: {
    newData () {
      if (!this.update.description && !this.update.name) return false
      else return true
    }
  },
  methods: {
    confirmUpdateForm (form) {
      this.$dialog.confirm({
        title: `Update Form`,
        message: `Are you sure you want to <b>save</b> your changes to this form?`,
        confirmText: 'Update',
        type: 'is-success',
        hasIcon: true,
        onConfirm: () => this.updateForm(form)
      })
    },
    updateForm (formData) {
      this.$apollo.mutate({
        mutation: UPDATE_FORM_MUTATION,
        variables: {
          id: formData.id,
          ...this.update
        },
        update: (store) => {
          const data = store.readQuery({
            query: ALL_FORMS_QUERY,
            variables: { formId: formData.id }
          })
          data.allForms = data.allForms.map(form => {
            if (form.id === formData.id) {
              form.name = this.update.name || form.name
              form.description = this.update.description || form.description
            }
            return form
          })
          store.writeQuery({ query: ALL_FORMS_QUERY, data })
        }
      }).then(() => {
        this.editMode = !this.editMode
        this.$toast.open('Form updated!')
      }).catch(err => console.error(err))
    },
    confirmDeleteForm (form) {
      this.$dialog.confirm({
        title: `Deleting form`,
        message: `Are you sure you want to <b>delete</b> this form? This action cannot be undone.`,
        confirmText: 'Delete Form',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: () => this.deleteForm(form)
      })
    },
    deleteForm (formData) {
      this.$apollo.mutate({
        mutation: DELETE_FORM_MUTATION,
        variables: {
          id: formData.id
        },
        update: (store) => {
          const data = store.readQuery({
            query: ALL_FORMS_QUERY,
            variables: { formId: formData.id }
          })
          data.allForms = data.allForms.filter(form => form.id !== formData.id)
          store.writeQuery({ query: ALL_FORMS_QUERY, data })
        }
      }).then(() => {
        this.$toast.open('Form deleted!')
      }).catch(err => console.error(err))
    }
  }
}
</script>

<style lang="scss" scoped>
.field {
  margin: 0.4rem;
}

button.card-footer-item {
  background-color: transparent;
  border: none;
  font-size: 1rem;
  cursor: pointer;
}
</style>
